{
  open Ex7_parser      (* The type token is defined in parser.mli *)
  exception Eof
  let global = ref 0
}
rule token = parse
    [' ' '\t' '\r']     { token lexbuf }     (* skip blanks *)
  | ['\n' ]             { global := !global + 1; EOL }
  | ['0'-'9']+ as lxm   { INT(int_of_string lxm) }
  | '+'                 { PLUS }
  | '*'                 { TIMES }
  | '('                 { LPAREN }
  | ')'                 { RPAREN }
  | eof                 { raise Eof }
  | _ as lxm            { Printf.printf "Illegal char %c at %d\n" lxm !global;
                          failwith "Bad input" }
